/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Remctl.xs. Do not edit this file, edit Remctl.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Remctl.xs"
/*  $Id: Remctl.xs 3291 2007-07-06 08:10:09Z rra $
**
**  Perl bindings for the remctl client library.
**
**  This is an XS source file, suitable for processing by xsubpp, that
**  generates Perl bindings for the libremctl client library.  It supports
**  both the simplified interface (via a simple remctl call) and the more
**  complex interface (returning a Net::Remctl object which is then used for
**  subsequent calls).
**
**  The remctl opaque struct is mapped to a Net::Remctl object and supports
**  methods equivalent to the library functions prefixed by remctl_ that take
**  struct remctl * as their first argument.  remctl_new() is mapped to the
**  new method of the class.  remctl_output structs are returned as
**  Net::Remctl::Output objects with accessor functions that return the
**  elements of the remctl_output struct.  The types (output, status, error,
**  and done) are returned as lowercase strings rather than as numeric
**  constants.
**
**  The simple interface is available via an exported remctl function which
**  returns a Net::Remctl::Result object with accessor functions for the
**  members of the struct.
**
**  Written by Russ Allbery <rra@stanford.edu>
**  Copyright 2007 Board of Trustees, Leland Stanford Jr. University
**
**  See README for licensing terms.
*/

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#include <errno.h>

#include <remctl.h>

/*
 * These typedefs are needed for xsubpp to work its magic with type
 * translation to Perl objects.
 */
typedef struct remctl *         Net__Remctl;
typedef struct remctl_result *  Net__Remctl__Result;
typedef struct remctl_output *  Net__Remctl__Output;

/* Map the remctl_output type constants to strings. */
const struct {
    enum remctl_output_type type;
    const char *name;
} OUTPUT_TYPE[] = {
    { REMCTL_OUT_OUTPUT, "output" },
    { REMCTL_OUT_STATUS, "status" },
    { REMCTL_OUT_ERROR,  "error"  },
    { REMCTL_OUT_DONE,   "done"   },
    { 0,                 NULL     }
};

/* XS code below this point. */

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 74 "Remctl.c"

XS(XS_Net__Remctl_remctl); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_remctl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::remctl", "host, port, principal, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	host = (const char *)SvPV_nolen(ST(0));
	unsigned short	port = (unsigned short)SvUV(ST(1));
	const char *	principal = (const char *)SvPV_nolen(ST(2));
#line 70 "Remctl.xs"
    size_t count = items - 3;
    size_t i;
    const char **command;
#line 95 "Remctl.c"
	Net__Remctl__Result	RETVAL;
#line 74 "Remctl.xs"
    if (items <= 3)
        croak("Too few arguments to Net::Remctl::remctl");
    if (principal != NULL && *principal == '\0')
        principal = NULL;
    command = malloc(sizeof(char *) * (count + 1));
    if (command == NULL)
        croak("Error allocating memory in Net::Remctl::remctl: %s",
              strerror(errno));
    for (i = 0; i <= count; i++)
        command[i] = SvPV_nolen(ST(i + 3));
    command[count] = NULL;
    RETVAL = remctl(host, port, principal, command);
    if (RETVAL == NULL)
        croak("Error creating Net::Remctl::Result object: %s",
              strerror(errno));
    free(command);
#line 114 "Remctl.c"
	ST(0) = sv_newmortal();
    if (RETVAL == NULL)
        ST(0) = &PL_sv_undef;
    else
        sv_setref_pv(ST(0), "Net::Remctl::Result", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::new", "class");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	class = (const char *)SvPV_nolen(ST(0));
	Net__Remctl	RETVAL;
#line 97 "Remctl.xs"
    RETVAL = remctl_new();
    if (RETVAL == NULL)
        croak("Error creating %s object: %s", class, strerror(errno));
#line 143 "Remctl.c"
	ST(0) = sv_newmortal();
    if (RETVAL == NULL)
        ST(0) = &PL_sv_undef;
    else
        sv_setref_pv(ST(0), "Net::Remctl", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::DESTROY", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl	self;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 107 "Remctl.xs"
    if (self != NULL)
        remctl_close(self);
#line 179 "Remctl.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__Remctl_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::open", "self, host, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;
	const char *	host = (const char *)SvPV_nolen(ST(1));
#line 115 "Remctl.xs"
    size_t count = items - 2;
    unsigned short port = 0;
    const char *principal = NULL;
#line 205 "Remctl.c"

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 119 "Remctl.xs"
    if (count > 2)
        croak("Too many arguments to Net::Remctl::open");
    if (count >= 1)
        port = SvUV(ST(2));
    if (count >= 2 && ST(3) != &PL_sv_undef)
        principal = SvPV_nolen(ST(3));
    if (remctl_open(self, host, port, principal))
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 226 "Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_command); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_command)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::command", "self, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__Remctl	self;
#line 134 "Remctl.xs"
    struct iovec *args;
    size_t count = items - 1;
    size_t i;
    int status;
#line 253 "Remctl.c"

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };
#line 139 "Remctl.xs"
    if (count == 0)
        croak("Too few arguments to Net::Remctl::command");
    args = malloc(sizeof(struct iovec) * count);
    if (args == NULL)
        croak("Error allocating memory in Net::Remctl::command: %s",
              strerror(errno));
    for (i = 1; i <= count; i++)
        args[i - 1].iov_base = SvPV(ST(i), args[i - 1].iov_len);
    status = remctl_commandv(self, args, count);
    free(args);
    if (status)
        XSRETURN_YES;
    else
        XSRETURN_UNDEF;
#line 278 "Remctl.c"
	PUTBACK;
	return;
    }
}


XS(XS_Net__Remctl_output); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_output)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::output", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl	self;
	Net__Remctl__Output	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };

	RETVAL = remctl_output(self);
	ST(0) = sv_newmortal();
    if (RETVAL == NULL)
        ST(0) = &PL_sv_undef;
    else
        sv_setref_pv(ST(0), "Net::Remctl::Output", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::error", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl	self;
	const char *	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl, tmp);
    } else {
        croak("self is not of type Net::Remctl");
    };

	RETVAL = remctl_error(self);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Result::DESTROY", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Result	self;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 168 "Remctl.xs"
    remctl_result_free(self);
#line 376 "Remctl.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__Remctl__Result_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Result::error", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Result	self;
	char *	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 174 "Remctl.xs"
    RETVAL = self->error;
#line 408 "Remctl.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_stdout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_stdout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Result::stdout", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Result	self;
	SV *	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 182 "Remctl.xs"
    if (self->stdout_buf == NULL)
        XSRETURN_UNDEF;
    else
        RETVAL = newSVpvn(self->stdout_buf, self->stdout_len);
#line 443 "Remctl.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_stderr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_stderr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Result::stderr", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Result	self;
	SV *	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 193 "Remctl.xs"
    if (self->stderr_buf == NULL)
        XSRETURN_UNDEF;
    else
        RETVAL = newSVpvn(self->stderr_buf, self->stderr_len);
#line 479 "Remctl.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Result_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Result_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Result::status", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Result	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Result")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Result, tmp);
    } else {
        croak("self is not of type Net::Remctl::Result");
    };
#line 204 "Remctl.xs"
    RETVAL = self->status;
#line 513 "Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Output::type", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Output	self;
#line 214 "Remctl.xs"
    size_t i;
#line 535 "Remctl.c"
	const char *	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 216 "Remctl.xs"
    RETVAL = NULL;
    for (i = 0; OUTPUT_TYPE[i].name != NULL; i++)
        if (OUTPUT_TYPE[i].type == self->type) {
            RETVAL = OUTPUT_TYPE[self->type].name;
            break;
        }
#line 554 "Remctl.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Output::data", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Output	self;
	SV *	RETVAL;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 229 "Remctl.xs"
    if (self->data == NULL)
        XSRETURN_UNDEF;
    else
        RETVAL = newSVpvn(self->data, self->length);
#line 589 "Remctl.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_length)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Output::length", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Output	self;
	size_t	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 240 "Remctl.xs"
    RETVAL = self->length;
#line 623 "Remctl.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Output::stream", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Output	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 248 "Remctl.xs"
    RETVAL = self->stream;
#line 656 "Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Output::status", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Output	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 256 "Remctl.xs"
    RETVAL = self->status;
#line 689 "Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__Remctl__Output_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__Remctl__Output_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Net::Remctl::Output::error", "self");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Net__Remctl__Output	self;
	int	RETVAL;
	dXSTARG;

    if (ST(0) == &PL_sv_undef) {
        self = NULL;
    } else if (sv_isa(ST(0), "Net::Remctl::Output")) {
        IV tmp = SvIV((SV *) SvRV(ST(0)));
        self = INT2PTR(Net__Remctl__Output, tmp);
    } else {
        croak("self is not of type Net::Remctl::Output");
    };
#line 264 "Remctl.xs"
    RETVAL = self->error;
#line 722 "Remctl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Net__Remctl); /* prototype to pass -Wmissing-prototypes */
XS(boot_Net__Remctl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Net::Remctl::remctl", XS_Net__Remctl_remctl, file, "$$$;@");
        newXSproto("Net::Remctl::new", XS_Net__Remctl_new, file, "$");
        newXSproto("Net::Remctl::DESTROY", XS_Net__Remctl_DESTROY, file, "$");
        newXSproto("Net::Remctl::open", XS_Net__Remctl_open, file, "$$;@");
        newXSproto("Net::Remctl::command", XS_Net__Remctl_command, file, "$;@");
        newXSproto("Net::Remctl::output", XS_Net__Remctl_output, file, "$");
        newXSproto("Net::Remctl::error", XS_Net__Remctl_error, file, "$");
        newXSproto("Net::Remctl::Result::DESTROY", XS_Net__Remctl__Result_DESTROY, file, "$");
        newXSproto("Net::Remctl::Result::error", XS_Net__Remctl__Result_error, file, "$");
        newXSproto("Net::Remctl::Result::stdout", XS_Net__Remctl__Result_stdout, file, "$");
        newXSproto("Net::Remctl::Result::stderr", XS_Net__Remctl__Result_stderr, file, "$");
        newXSproto("Net::Remctl::Result::status", XS_Net__Remctl__Result_status, file, "$");
        newXSproto("Net::Remctl::Output::type", XS_Net__Remctl__Output_type, file, "$");
        newXSproto("Net::Remctl::Output::data", XS_Net__Remctl__Output_data, file, "$");
        newXSproto("Net::Remctl::Output::length", XS_Net__Remctl__Output_length, file, "$");
        newXSproto("Net::Remctl::Output::stream", XS_Net__Remctl__Output_stream, file, "$");
        newXSproto("Net::Remctl::Output::status", XS_Net__Remctl__Output_status, file, "$");
        newXSproto("Net::Remctl::Output::error", XS_Net__Remctl__Output_error, file, "$");
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

